package pl.webnet.JaTrac;

import java.awt.*;

class GradientColorMap extends Texture
{
	Color u0v0, u1v0, u0v1, u1v1;

	public GradientColorMap(Color c0, Color c1, Color c2, Color c3)
	{
		u0v0 = c0;
		u1v0 = c1;
		u0v1 = c2;
		u1v1 = c3;
	}

	public Spectrum updateSpectrum(Spectrum s, Point uv)
	{
		float r, g, b;
		float r0, g0, b0;
		float r1, g1, b1;
		float[] c0, c1, c2, c3;
		float u = (float)uv.x;
		float v = (float)uv.y;

		u *= 2;
		if(u > 1.)
			u = 2 - u;
			
		c0 = u0v0.getColorComponents(null);
		c1 = u1v0.getColorComponents(null);
		c2 = u0v1.getColorComponents(null);
		c3 = u1v1.getColorComponents(null);

		// interpolate along top edge
		r0 = c1[0] * u + c0[0] * (1 - u);
		g0 = c1[1] * u + c0[1] * (1 - u);
		b0 = c1[2] * u + c0[2] * (1 - u);

		// interpolate along bottom edge
		r1 = c3[0] * u + c2[0] * (1 - u);
		g1 = c3[1] * u + c2[1] * (1 - u);
		b1 = c3[2] * u + c2[2] * (1 - u);

		// interpolate along v dimension
		r = r1 * (1 - v) + r0 * v;
		g = g1 * (1 - v) + g0 * v;
		b = b1 * (1 - v) + b0 * v;


		return s.create(r,g,b);
	}
}
