package pl.webnet.JaTrac;

class SphericalMapping extends Mapping
{
	final double recPI = 1 / Math.PI;
	final double recTwoPI = 1 / (2 * Math.PI);
	Point center;
//	double radius;
	Vec sPole, sEquator;
	Vec crossSpSe;

	public SphericalMapping(Point center, Vec sp, Vec se)
	{
		sPole = new Vec(sp);
		sEquator = new Vec(se);
		crossSpSe = sPole.cross(sEquator);
	}

	public Point getUV(Point hitPoint, Vec normal)
	{
		double u, v;
		double lat, lon;
		
		lat = Math.acos(-normal.dot(sPole));
		v = lat * recPI;

		if(v < Ray.EPSILON || Math.abs(1 - v) < Ray.EPSILON)
			u = 0.;
		else
		{
			double ratio = sEquator.dot(normal) / Math.sin(lat);

			if(ratio < -1)
				ratio = -1;
			else
				if(ratio > 1)
					ratio = 1;

			lon = Math.acos(ratio) * recTwoPI;
			
//		System.out.println("val: " + Math.acos(sEquator.dot(normal) / Math.sin(lat)));
	//	System.out.println("acos and sine: " + sEquator.dot(normal) + " " + Math.sin(lat));

			if(crossSpSe.dot(normal) > 0)
				u = lon;
			else
				u = 1 - lon;
		}

		return new Point(u, v, 0.);
	}
}
